import brain from './src';
import { FeedForward, layer } from './src';
import { predict as weighPredict } from './src/layer/weigh';
const {
  input,
  output,
  feedForward
} = layer;


const net = new FeedForward({
  inputLayer: () => input({ width: 6, height: 1 }),
  hiddenLayers: [
    (input) => feedForward({ width: 4 }, input)
  ],
  outputLayer: (input) => output({ width: 2, height: 1 }, input)
});

net.initialize();


// run with: `babel-node --presets=babel-preset-es2015 test5.js`
const result = net.train([{ input: [[1,1,1,1,1,1]], output: [[0,0]] }]); // --> [ [ [ 0.5 ] ] ]
console.log(result);
//
// const net = new brain.NeuralNetwork({
//   layers: [4]
// });
//
// net.train([{ input: [1,1,1,1,1,1], output: [0,0] }], { iterations: 0 });
// console.log(JSON.stringify(net.toJSON(), null, 2));

// (function() {
//   let input = [0, 1, 2, 3];
//   let weights = [0, 1, 2, 3];
//
//   let sum = 0;
//   for (let k = 0; k < weights.length; k++) {
//     sum += weights[k] * input[k];
//   }
//
//   console.log(sum);
// })();
//
// (function() {
//   let input = [0,1,2,3];
//   let weights = [0,1,2,3];
//
//
//   weighPredict
// })();

